unit uInstanceController;

interface

type
  TInstanceController = class
  strict private
    class var
      FMutexName  : String;
      FMutexHandle: THandle;

  public
    class function IsAlphaInstance: Boolean;
    class procedure RegisterInstance;
    class procedure UnregisterInstance;

    class property MutexName: String read FMutexName write FMutexName;
  end;

implementation

uses
  Winapi.Windows;

class function TInstanceController.IsAlphaInstance: Boolean;
var
  hMutex: THandle;
begin
  hMutex := OpenMutex(SYNCHRONIZE, FALSE, PChar(FMutexName));
  if hMutex = 0 then
    Exit(TRUE);

  CloseHandle(hMutex);
  Exit(FALSE);
end;

class procedure TInstanceController.RegisterInstance;
begin
  FMutexHandle := CreateMutex(nil, FALSE, PChar(FMutexName));
end;

class procedure TInstanceController.UnregisterInstance;
begin
  ReleaseMutex(FMutexHandle);
end;

end.
