unit uQueue;

interface

uses
  Generics.Collections;

type
  TQueueEvent = (qeCommand, qeOpenPort, qeInitialize);

  TQueueItem = class
  private
    FCommand : String;
    FResponse: String;
    FPort    : String;
    FEvent   : TQueueEvent;

  public
    constructor Create(const AEvent: TQueueEvent; const AData: String = ''); overload;

    property Command : String read FCommand;
    property Response: String read FResponse;
    property Port    : String read FPort;
    property Event   : TQueueEvent read FEvent;
  end;

  TQueue = TObjectList<TQueueItem>;

implementation

uses
  System.SysUtils;


constructor TQueueItem.Create(const AEvent: TQueueEvent; const AData: String = '');
begin
  FEvent := AEvent;

  case FEvent of
    qeCommand   : begin
                    Assert(Pos(';', AData) > 0, Format('Invalid script line, semicolon required [%s]!', [AData]));
                    FCommand := Trim(Copy(AData, 1, Pos(';', AData) - 1));
                    FResponse := Trim(Copy(AData, Pos(';', AData) + 1, Length(AData) - Pos(';', AData)));
                  end;

    qeOpenPort  : begin
                    FPort := AData;
                  end;
  end;
end;

end.
