unit uStartup;

interface

uses
  Winapi.Windows;

type
  TStartup = class
  private
    const
      KEY_ROOT = HKEY_CURRENT_USER;
      KEY_PATH = 'SOFTWARE\Microsoft\Windows\CurrentVersion\Run';
      KEY_NAME = 'SkypeDiverter';

  public
    class function Install: Boolean;
    class procedure Uninstall;
    class function IsInstalled: Boolean;
  end;

implementation

uses
  System.SysUtils, System.Win.Registry;

{ TStartup }

class function TStartup.Install: Boolean;
var
  reg: TRegistry;
begin
  result := FALSE;
  reg := TRegistry.Create;
  try
    reg.RootKey := KEY_ROOT;
    if reg.OpenKey(KEY_PATH, TRUE) then
    begin
      reg.WriteString(KEY_NAME, Format('"%s" /minimized', [ParamStr(0)]));
      reg.CloseKey;
      Exit(reg.ValueExists(KEY_NAME));
    end;
  finally
    reg.Free;
  end;
end;

class procedure TStartup.Uninstall;
var
  reg: TRegistry;
begin
  reg := TRegistry.Create;
  try
    reg.RootKey := KEY_ROOT;
    if reg.OpenKey(KEY_PATH, TRUE) then
    begin
      reg.DeleteValue(KEY_NAME);
      reg.CloseKey;
    end;
  finally
    reg.Free;
  end;
end;

class function TStartup.IsInstalled: Boolean;
var
  reg: TRegistry;
begin
  result := FALSE;
  reg := TRegistry.Create;
  try
    reg.RootKey := KEY_ROOT;
    if reg.OpenKey(KEY_PATH, FALSE) then
    begin
      result := reg.ValueExists(KEY_NAME);
      reg.CloseKey;
    end;
  finally
    reg.Free;
  end;
end;


end.
