unit uMainDataModule;

interface

uses
  SKYPE4COMLib_TLB, uModemList, uSettings, uModemComm,
  System.SysUtils, System.Classes;

type
  TdmMain = class(TDataModule)
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleDestroy(Sender: TObject);
  private
    FModems    : TModemList;
    FModemComm : TModemComm;
    FSkype     : TSkype;
    FSettings  : TSettings;

  public
    property Modems             : TModemList read FModems;
    property ModemCommunication : TModemComm read FModemComm;
    property Skype              : TSkype read FSkype;
    property Settings           : TSettings read FSettings;

  end;

var
  dmMain: TdmMain;

implementation

{%CLASSGROUP 'System.Classes.TPersistent'}

{$R *.dfm}

procedure TdmMain.DataModuleCreate(Sender: TObject);
begin
  FSettings := TSettings.Create('settings.dat');
  FSettings.LoadSettings;

  FModems := TModemList.Create;
  FModems.Refresh;

  FModemComm := TModemComm.Create;
  FModemComm.SetScript(FSettings.ModemScript);
  FModemComm.Start;

  FSkype := TSkype.Create(nil);
end;

procedure TdmMain.DataModuleDestroy(Sender: TObject);
begin
  FSkype.Free;

  FModemComm.Shutdown;
  FModemComm.Free;

  FModems.Free;

  FSettings.SaveSettings;
  FSettings.Free;
end;

end.
